Index: /trunk/configure.ac
===================================================================
--- /trunk/configure.ac	(revision 8366)
+++ /trunk/configure.ac	(revision 8367)
@@ -575,5 +575,5 @@
 	AC_PATH_PROG([QT_RCC], [rcc], [no], ["${QT_BIN_DIRECTORY}:${PATH}"])
 
-	AC_SUBST([QT_RCC])	
+	AC_SUBST([QT_RCC])
 	AC_SUBST( QT_INCLUDE_DIR )
 	AC_SUBST( QT_CFLAGS )
@@ -582,5 +582,5 @@
 	echo "QT_LIBS 			= $QT_LIBS"
 	echo "QT_CFLAGS 		= $QT_CFLAGS"
-	echo "QT_INCLUDE_DIR 	= $QT_INCLUDE_DIR"		
+	echo "QT_INCLUDE_DIR 	= $QT_INCLUDE_DIR"
 else
 	AX_CHECK_QT([${QT_PREFIX}], [QtCore QtCore4],, [http://www.trolltech.com])
@@ -642,4 +642,5 @@
                  src/lib/Makefile
                  src/lib/math/Makefile
+                 src/lib/util/Makefile
                  src/lib/graphics/Makefile
                  src/lib/graphics/importer/Makefile
Index: /trunk/src/lib/BuildLibs.am
===================================================================
--- /trunk/src/lib/BuildLibs.am	(revision 8366)
+++ /trunk/src/lib/BuildLibs.am	(revision 8367)
@@ -24,3 +24,4 @@
                 $(LIB_PREFIX)/shell/libORXshell.a \
                 $(LIB_PREFIX)/math/libORXmath.a \
+                $(LIB_PREFIX)/util/libORXlibutil.a \
                 $(LIB_PREFIX)/libORXlibs.a
Index: /trunk/src/lib/Makefile.am
===================================================================
--- /trunk/src/lib/Makefile.am	(revision 8366)
+++ /trunk/src/lib/Makefile.am	(revision 8367)
@@ -10,27 +10,4 @@
 		coord/p_node.cc \
 		\
-		util/substring.cc \
-		util/color.cc \
-		util/helper_functions.cc \
-		util/multi_type.cc \
-		util/executor/executor.cc \
-		util/executor/executor_functional.cc \
-		util/executor/executor_lua.cc \
-		\
-		util/loading/resource_manager.cc \
-		util/loading/resource.cc \
-		util/loading/game_loader.cc \
-		util/loading/load_param.cc \
-		util/loading/load_param_description.cc \
-		util/loading/factory.cc \
-		util/loading/dynamic_loader.cc \
-		\
-		util/filesys/file.cc \
-		util/filesys/directory.cc \
-		\
-		util/preferences.cc \
-		util/threading.cc \
-		util/timer.cc \
-		\
 		data/data_tank.cc
 
@@ -41,33 +18,4 @@
 		coord/p_node.h \
 		\
-		util/substring.h \
-		util/multi_type.h \
-		util/color.h \
-		util/helper_functions.h \
-		util/executor/executor.h \
-		util/executor/executor_functional.h \
-		util/executor/executor_xml.h \
-		util/executor/executor_lua.h \
-		util/executor/functor_list.h \
-		\
-		util/filesys/file.h \
-		util/filesys/directory.h \
-		\
-		util/preferences.h \
-		util/threading.h \
-		util/timer.h \
-		\
-		util/loading/resource_manager.h \
-		util/loading/resource.h \
-		util/loading/game_loader.h \
-		util/loading/load_param.h \
-		util/loading/load_param_description.h \
-		util/loading/factory.h \
-		util/loading/dynamic_loader.h \
-		\
-		util/count_pointer.h \
-		util/list.h \
-		\
-		\
 		data/data_tank.h
 
@@ -75,4 +23,5 @@
 	. \
 	math \
+	util \
 	graphics \
 	sound \
Index: /trunk/src/lib/util/Makefile.am
===================================================================
--- /trunk/src/lib/util/Makefile.am	(revision 8367)
+++ /trunk/src/lib/util/Makefile.am	(revision 8367)
@@ -0,0 +1,57 @@
+MAINSRCDIR=../..
+include $(MAINSRCDIR)/defs/include_paths.am
+
+noinst_LIBRARIES = libORXlibutil.a
+
+libORXlibutil_a_SOURCES = \
+		substring.cc \
+		color.cc \
+		helper_functions.cc \
+		multi_type.cc \
+		executor/executor.cc \
+		executor/executor_functional.cc \
+		executor/executor_lua.cc \
+		\
+		loading/resource_manager.cc \
+		loading/resource.cc \
+		loading/game_loader.cc \
+		loading/load_param.cc \
+		loading/load_param_description.cc \
+		loading/factory.cc \
+		loading/dynamic_loader.cc \
+		\
+		filesys/file.cc \
+		filesys/directory.cc \
+		\
+		preferences.cc \
+		threading.cc \
+		timer.cc
+
+noinst_HEADERS = \
+		substring.h \
+		multi_type.h \
+		color.h \
+		helper_functions.h \
+		executor/executor.h \
+		executor/executor_functional.h \
+		executor/executor_xml.h \
+		executor/executor_lua.h \
+		executor/functor_list.h \
+		\
+		filesys/file.h \
+		filesys/directory.h \
+		\
+		preferences.h \
+		threading.h \
+		timer.h \
+		\
+		loading/resource_manager.h \
+		loading/resource.h \
+		loading/game_loader.h \
+		loading/load_param.h \
+		loading/load_param_description.h \
+		loading/factory.h \
+		loading/dynamic_loader.h \
+		\
+		count_pointer.h \
+		list.h