Index: /trunk/src/lib/graphics/importer/material.cc
===================================================================
--- /trunk/src/lib/graphics/importer/material.cc	(revision 8368)
+++ /trunk/src/lib/graphics/importer/material.cc	(revision 8369)
@@ -196,13 +196,4 @@
 
 /**
- *  Sets the Material Illumination Model.
- *  illu illumination Model in char* form
- */
-void Material::setIllum (char* illum)
-{
-  this->setIllum (atoi(illum));
-}
-
-/**
  *  Sets the Material Diffuse Color.
  * @param r Red Color Channel.a
@@ -220,14 +211,4 @@
 }
 
-/**
- *  Sets the Material Diffuse Color.
- * @param rgb The red, green, blue channel in char format (with spaces between them)
- */
-void Material::setDiffuse (char* rgb)
-{
-  float r,g,b;
-  sscanf (rgb, "%f %f %f", &r, &g, &b);
-  this->setDiffuse (r, g, b);
-}
 
 /**
@@ -247,15 +228,4 @@
 
 /**
- *  Sets the Material Ambient Color.
- * @param rgb The red, green, blue channel in char format (with spaces between them)
- */
-void Material::setAmbient (char* rgb)
-{
-  float r,g,b;
-  sscanf (rgb, "%f %f %f", &r, &g, &b);
-  this->setAmbient (r, g, b);
-}
-
-/**
  *  Sets the Material Specular Color.
  * @param r Red Color Channel.
@@ -273,15 +243,4 @@
 
 /**
- *  Sets the Material Specular Color.
- * @param rgb The red, green, blue channel in char format (with spaces between them)
-*/
-void Material::setSpecular (char* rgb)
-{
-  float r,g,b;
-  sscanf (rgb, "%f %f %f", &r, &g, &b);
-  this->setSpecular (r, g, b);
-}
-
-/**
  *  Sets the Material Shininess.
  * @param shini stes the Shininess from float.
@@ -291,12 +250,4 @@
   this->shininess = shini;
 }
-/**
- *  Sets the Material Shininess.
- * @param shini stes the Shininess from char*.
-*/
-void Material::setShininess (char* shini)
-{
-  this->setShininess (atof(shini));
-}
 
 /**
@@ -308,12 +259,4 @@
   PRINTF(4)("setting Transparency of Material %s to %f.\n", this->getName(), trans);
   this->transparency = trans;
-}
-/**
- *  Sets the Material Transparency.
- * @param trans stes the Transparency from char*.
-*/
-void Material::setTransparency (char* trans)
-{
-  this->setTransparency (atof(trans));
 }
 
Index: /trunk/src/lib/graphics/importer/material.h
===================================================================
--- /trunk/src/lib/graphics/importer/material.h	(revision 8368)
+++ /trunk/src/lib/graphics/importer/material.h	(revision 8369)
@@ -42,13 +42,4 @@
     void setBlendFunc(GLenum sFactor, GLenum tFactor) { this->sFactor = sFactor; this->tFactor = tFactor; };
 
-
-    // TODO Move them out of here
-    void setIllum (char* illum);
-    void setDiffuse (char* rgb);
-    void setAmbient (char* rgb);
-    void setSpecular (char* rgb);
-    void setShininess (char* shini);
-    void setTransparency (char* trans);
-
     void getDiffuseColor(float& r, float& g, float& b) const { r = diffuse[0], g = diffuse[1], b = diffuse[2]; }
 
Index: /trunk/src/lib/graphics/importer/objModel.cc
===================================================================
--- /trunk/src/lib/graphics/importer/objModel.cc	(revision 8368)
+++ /trunk/src/lib/graphics/importer/objModel.cc	(revision 8369)
@@ -28,5 +28,5 @@
 
 /**
- *  Crates a 3D-Model, loads in a File and scales it.
+ * @brief Crates a 3D-Model, loads in a File and scales it.
  * @param fileName file to parse and load (must be a .obj file)
  * @param scaling The factor that the model will be scaled with.
@@ -47,8 +47,6 @@
 
 /**
- *  deletes an OBJModel.
-
-   Looks if any from model allocated space is still in use, and if so deleted it.
-*/
+ * @brief deletes an OBJModel.
+ */
 OBJModel::~OBJModel()
 { }
@@ -86,7 +84,9 @@
 
 /**
- *  Reads in the .obj File and sets all the Values.
-   This function does read the file, parses it for the occurence of things like vertices, faces and so on, and executes the specific tasks
-*/
+ * @brief Reads in the .obj File and sets all the Values.
+ * @param fileName the FileName of the Model.
+ *
+ * This function does read the file, parses it for the occurence of things like vertices, faces and so on, and executes the specific tasks
+ */
 bool OBJModel::readFromObjFile(const std::string& fileName)
 {
@@ -153,5 +153,5 @@
 
 /**
- * Function to read in a mtl File.
+ * @brief Function to read in a mtl File.
  * @param mtlFile The .mtl file to read
  *
@@ -191,5 +191,5 @@
         {
           if (likely(tmpMat != NULL))
-            tmpMat->setIllum(buffer+6);
+            setIllum(tmpMat, buffer+6);
 
         }
@@ -198,5 +198,5 @@
         {
           if (likely(tmpMat != NULL))
-            tmpMat->setDiffuse(buffer+3);
+            setDiffuse(tmpMat, buffer+3);
         }
       // setting Ambient Color
@@ -204,5 +204,5 @@
         {
           if (likely(tmpMat != NULL))
-            tmpMat->setAmbient(buffer+3);
+            setAmbient(tmpMat, buffer+3);
         }
       // setting Specular Color
@@ -210,5 +210,5 @@
         {
           if (likely(tmpMat != NULL))
-            tmpMat->setSpecular(buffer+3);
+            setSpecular(tmpMat, buffer+3);
         }
       // setting The Specular Shininess
@@ -216,5 +216,5 @@
         {
           if (likely(tmpMat != NULL))
-            tmpMat->setShininess(buffer+3);
+            setShininess(tmpMat, buffer+3);
         }
       // setting up transparency
@@ -222,10 +222,10 @@
         {
           if (likely(tmpMat != NULL))
-            tmpMat->setTransparency(buffer+2);
+            setTransparency(tmpMat, buffer+2);
         }
       else if (!strncmp(buffer, "Tf ", 3))
         {
           if (likely(tmpMat != NULL))
-            tmpMat->setTransparency(buffer+3);
+            setTransparency(tmpMat, buffer+3);
         }
 
@@ -256,2 +256,69 @@
   return true;
 }
+
+
+/**
+ * @brief Sets the Material Illumination Model.
+ * @param material: the Material to apply the change to.
+ * @param illu: illumination Model in char* form
+ */
+void OBJModel::setIllum (Material* material, const char* illum)
+{
+  material->setIllum (atoi(illum));
+}
+
+/**
+ * @brief Sets the Material Diffuse Color.
+ * @param material: the Material to apply the change to.
+ * @param rgb The red, green, blue channel in char format (with spaces between them)
+ */
+void OBJModel::setDiffuse (Material* material, const char* rgb)
+{
+  float r,g,b;
+  sscanf (rgb, "%f %f %f", &r, &g, &b);
+  material->setDiffuse (r, g, b);
+}
+
+/**
+ * @brief Sets the Material Ambient Color.
+ * @param material: the Material to apply the change to.
+ * @param rgb The red, green, blue channel in char format (with spaces between them)
+ */
+void OBJModel::setAmbient (Material* material, const char* rgb)
+{
+  float r,g,b;
+  sscanf (rgb, "%f %f %f", &r, &g, &b);
+  material->setAmbient (r, g, b);
+}
+
+/**
+ * @brief Sets the Material Specular Color.
+ * @param material: the Material to apply the change to.
+ * @param rgb The red, green, blue channel in char format (with spaces between them)
+ */
+void OBJModel::setSpecular (Material* material, const char* rgb)
+{
+  float r,g,b;
+  sscanf (rgb, "%f %f %f", &r, &g, &b);
+  material->setSpecular (r, g, b);
+}
+
+/**
+ * @brief Sets the Material Shininess.
+ * @param material: the Material to apply the change to.
+ * @param shini stes the Shininess from char*.
+ */
+void OBJModel::setShininess (Material* material, const char* shini)
+{
+  material->setShininess (atof(shini));
+}
+
+/**
+ * @brief Sets the Material Transparency.
+ * @param material: the Material to apply the change to.
+ * @param trans stes the Transparency from char*.
+ */
+void OBJModel::setTransparency (Material* material, const char* trans)
+{
+  material->setTransparency (atof(trans));
+}
Index: /trunk/src/lib/graphics/importer/objModel.h
===================================================================
--- /trunk/src/lib/graphics/importer/objModel.h	(revision 8368)
+++ /trunk/src/lib/graphics/importer/objModel.h	(revision 8369)
@@ -22,4 +22,12 @@
    bool readMtlLib (const std::string& matFile);
 
+  private:
+   void setIllum (Material* material, const char* illum);
+   void setDiffuse (Material* material, const char* rgb);
+   void setAmbient (Material* material, const char* rgb);
+   void setSpecular (Material* material, const char* rgb);
+   void setShininess (Material* material, const char* shini);
+   void setTransparency (Material* material, const char* trans);
+
  private:
    std::string       objPath;     //!< The Path where the obj and mtl-file are located.