Index: /code/branches/tutoriallevel2/data/gui/scripts/NotificationLayer.lua
===================================================================
--- /code/branches/tutoriallevel2/data/gui/scripts/NotificationLayer.lua	(revision 8376)
+++ /code/branches/tutoriallevel2/data/gui/scripts/NotificationLayer.lua	(revision 8377)
@@ -31,5 +31,5 @@
         ["visible"]   = false,
         ["fontSize"]  = 12,
-        ["fontColor"] = "#FFFFFFFF",
+        ["fontColor"] = "FFFFFFFF",
         ["items"]     = {},
         ["first"]     = 1,
@@ -196,5 +196,5 @@
 
 -- Change the font size and font color of all notifications in a queueHeightHelper
--- The parameters are (in order) 'name of the queue', 'font size', 'RGBA of the font color in hex notation'.
+-- The parameters are (in order) 'name of the queue', 'font size', 'ARGB of the font color in hex notation'.
 function P.changeQueueFont(queueName, size, color)
     local queue = P.queueList[queueName]
@@ -227,5 +227,6 @@
     end
     if changeColor then
-        --item:setProperty("TextColours", "tl:[" .. queue.fontColor .. "] tr:[" .. queue.fontColor .. "] bl:[" .. queue.fontColor .. "] br:[" .. queue.fontColor .. "]")
+        item:setProperty("TextColours", "tl:" .. queue.fontColor .. " tr:" .. queue.fontColor .. " bl:" .. queue.fontColor .. " br:" .. queue.fontColor .. "")
+        cout(0, "tl:[" .. queue.fontColor .. "] tr:[" .. queue.fontColor .. "] bl:[" .. queue.fontColor .. "] br:[" .. queue.fontColor .. "]")
     end
 end
Index: /code/branches/tutoriallevel2/src/modules/notifications/NotificationDispatcher.cc
===================================================================
--- /code/branches/tutoriallevel2/src/modules/notifications/NotificationDispatcher.cc	(revision 8376)
+++ /code/branches/tutoriallevel2/src/modules/notifications/NotificationDispatcher.cc	(revision 8377)
@@ -113,5 +113,5 @@
         {
             const std::string message = this->createNotificationMessage();
-            NotificationListener::sendNotification(message, clientId, this->getSender());
+            NotificationListener::sendNotification(message, this->getSender(), notificationMessageMode::message, notificationSendMode::network, clientId);
         }
         else if(GameMode::isServer())
Index: /code/branches/tutoriallevel2/src/modules/questsystem/QuestDescription.cc
===================================================================
--- /code/branches/tutoriallevel2/src/modules/questsystem/QuestDescription.cc	(revision 8376)
+++ /code/branches/tutoriallevel2/src/modules/questsystem/QuestDescription.cc	(revision 8377)
@@ -119,5 +119,5 @@
         }
 
-        NotificationListener::sendNotification(message, player->getClientID(), QuestDescription::SENDER);
+        NotificationListener::sendNotification(message, QuestDescription::SENDER, notificationMessageMode::message, notificationSendMode::network, player->getClientID());
         return true;
     }
Index: /code/branches/tutoriallevel2/src/orxonox/interfaces/NotificationListener.h
===================================================================
--- /code/branches/tutoriallevel2/src/orxonox/interfaces/NotificationListener.h	(revision 8376)
+++ /code/branches/tutoriallevel2/src/orxonox/interfaces/NotificationListener.h	(revision 8377)
@@ -48,5 +48,21 @@
 namespace orxonox
 {
-    class Notification;
+    
+    namespace notificationMessageMode
+    {
+        enum Value {
+            message,
+            command
+        };
+    }
+    
+    namespace notificationSendMode
+    {
+        enum Value {
+            local,
+            network,
+            broadcast
+        };
+    }
 
     /**
@@ -71,8 +87,10 @@
             static const std::string NONE; //!< Static string to indicare a sender that sends to no specific NotificationListener.
             
-            static void sendNotification(const std::string& message, unsigned int clientId, const std::string& sender = NotificationListener::NONE, bool isLocal = false);
+            static void sendNotification(const std::string& message, const std::string& sender = NotificationListener::NONE, notificationMessageMode::Value messageMode = notificationMessageMode::message, notificationSendMode::Value sendMode = notificationSendMode::local, unsigned int clientId = 0);
+            static void sendNotificationHelper(const std::string& message, const std::string& sender, unsigned int messageMode);
             
             virtual bool registerNotification(const std::string& message, const std::string& sender)
                 { return false; }
+            virtual void executeCommand(const std::string& command, const std::string& sender) {}
     };
 }