Index: /branches/script_engine/src/lib/script_engine/lunar.h
===================================================================
--- /branches/script_engine/src/lib/script_engine/lunar.h	(revision 8384)
+++ /branches/script_engine/src/lib/script_engine/lunar.h	(revision 8385)
@@ -172,5 +172,5 @@
       static int new_T(lua_State *L) {
         lua_remove(L, 1);   // use classname:new(), instead of classname.new()
-        T *obj = new T(L);  // call constructor for T objects
+        T *obj = new T();  // call constructor for T objects
         push(L, obj, true); // gc_T will delete this object
         return 1;           // userdata containing pointer to T object
Index: /branches/script_engine/src/lib/script_engine/script_manager.cc
===================================================================
--- /branches/script_engine/src/lib/script_engine/script_manager.cc	(revision 8384)
+++ /branches/script_engine/src/lib/script_engine/script_manager.cc	(revision 8385)
@@ -38,5 +38,5 @@
 void ScriptManager::loadParams(const TiXmlElement* root)
 {
-  //BaseObject::loadParams(root);
+  BaseObject::loadParams(root);
   {
     LoadParamXML(root, "Scripts", this, ScriptManager, createScripts);
Index: /branches/script_engine/src/lib/util/executor/executor_lua.cc
===================================================================
--- /branches/script_engine/src/lib/util/executor/executor_lua.cc	(revision 8384)
+++ /branches/script_engine/src/lib/util/executor/executor_lua.cc	(revision 8385)
@@ -20,4 +20,5 @@
 std::string temp;
 
+template<typename type> type* fromLua(lua_State* state, int index) { type *obj = Lunar<type>::check(state, 1); return obj;};
 template<> bool fromLua<bool>(lua_State* state, int index) { return lua_toboolean(state, index); };
 template<> int fromLua<int>(lua_State* state, int index) { return (int)lua_tonumber(state, index); };
@@ -28,5 +29,5 @@
 
 
-
+template<typename type> void toLua(lua_State* state, type value) { Lunar<type>::push(state, value, false); };
 template<> void toLua<bool>(lua_State* state, bool value) { lua_pushboolean(state, (int) value); };
 template<> void toLua<int>(lua_State* state, int value)  { lua_pushnumber(state, (lua_Number) value); };
Index: /branches/script_engine/src/lib/util/executor/executor_lua.h
===================================================================
--- /branches/script_engine/src/lib/util/executor/executor_lua.h	(revision 8384)
+++ /branches/script_engine/src/lib/util/executor/executor_lua.h	(revision 8385)
@@ -11,8 +11,9 @@
 #include "debug.h"
 #include "luaincl.h"
-
-
-
-template<typename type> type fromLua(lua_State* state, int index) { PRINTF(1)("NOT IMPLEMENTED\n"); };
+#include "lunar.h"
+
+
+
+template<typename type> type fromLua(lua_State* state, int index);
 template<> bool fromLua<bool>(lua_State* state, int index);
 template<> int fromLua<int>(lua_State* state, int index);
@@ -23,5 +24,5 @@
 
 
-template<typename type> void toLua(lua_State* state, type value) { PRINTF(1)("NOT IMPLEMENTED\n"); };
+template<typename type> void toLua(lua_State* state, type value);
 template<> void toLua<bool>(lua_State* state, bool value);
 template<> void toLua<int>(lua_State* state, int value);
Index: /branches/script_engine/src/story_entities/game_world.cc
===================================================================
--- /branches/script_engine/src/story_entities/game_world.cc	(revision 8384)
+++ /branches/script_engine/src/story_entities/game_world.cc	(revision 8385)
@@ -186,5 +186,5 @@
   this->dataXML = (TiXmlElement*)root->Clone();
 
-
+  //remove this after finished testing !!!!
   Object* obj= new Object();
   obj->setName("Obj");
@@ -193,5 +193,6 @@
   Account *b = new Account(30);
   b->setName("b");
-  printf("ScriptManager created by game world\n");
+  
+  
   LoadParamXML(root, "ScriptManager", &this->scriptManager, ScriptManager, loadParams);
 
Index: /branches/script_engine/src/world_entities/space_ships/helicopter.cc
===================================================================
--- /branches/script_engine/src/world_entities/space_ships/helicopter.cc	(revision 8384)
+++ /branches/script_engine/src/world_entities/space_ships/helicopter.cc	(revision 8385)
@@ -35,4 +35,7 @@
 
 CREATE_FACTORY(Helicopter, CL_HELICOPTER);
+
+//CREATE_SCRIPTABLE_CLASS(Helicopter, CL_HELICOPTER);
+
 
 /**